angular.module('app.controllers')

.controller('bounceOffCtrl', ['$scope', '$stateParams', '$ionicPlatform', '$rootScope', '$state', '$http', '$ionicPopup', 'participantService', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $ionicPlatform, $rootScope, $state, $http, $ionicPopup, participantService) {
    
    $scope.title = "Main Menu";
    $scope.disableNav = "disable-anchor";
    $scope.vendorStallId =$rootScope.stallId;
    $scope.QR = $rootScope.QR;
    $scope.loggedInUserData.balance = $rootScope.loggedInUserData.balance;
    $scope.loggedInUserData.fullname = $rootScope.loggedInUserData.fullname;
    $scope.loggedInUserData.nric = $rootScope.loggedInUserData.nric;

    $scope.startScanQR = function(action){
        $rootScope.showLoader();

        cloudSky.zBar.scan({text_title: '', text_instructions: '', flash: 'off'}, function(result){
            
            console.log(result);
            participantService.getParticipantByQRCode(result).then(function(data){ 

                    try{
                        if(data.status === 1){
                            $rootScope.scannedParticipant = data.info;
                        }
                        else if(data.status === 0){
                            alert("Participant not found. Please try again.");
                            return;
                        }
                        else{
                            alert("Connection error when get participant info! Please try again.");
                            return;
                        }                   
                        
                        if(action === 'transaction'){                        
                            $scope.goTransactionHistory($rootScope.scannedParticipant.participant_id);
                        }
                        else{
                            $state.go('refund');
                        }
                        return;
                    }
                    finally{
                        $rootScope.hideLoader();
                    }                    
                }
            )
        },function(error){
            $rootScope.hideLoader();
        })
    }

    $scope.checkTransaction = function(){
        $scope.goTransactionHistory($rootScope.loggedInUserId);
    }

    $scope.refresh = function(){
        $rootScope.showLoader();
        participantService.getInfoById($rootScope.loggedInUserId).then(function(data){
            $rootScope.hideLoader();
            if(data.status === 1){
                $scope.loggedInUserData.balance = data.balance;
            }
            else{
                alert('Connection error, please try again!');
            }
        })
    }

    $scope.goTransactionHistory = function(participantId){
        $rootScope.showLoader();

        participantService.getTransactionListByParticipantId(participantId).then(
            function(data){
                if(data.status === 1){
                    $rootScope.transactionList = data.transaction;
                    $rootScope.participantName = data.participantName;
                    $rootScope.currentBalance = data.currentBalance;
                    $state.go('historyTransaction');
                }
                else if(data.status === 0){
                    alert("Get history transaction error! Please try again.");
                }
                else{
                    alert("Connection error when get transaction info! Please try again.");
                }
                $rootScope.hideLoader();
            }
        );
    }
    
    $scope.changePassword = function(){
        $state.go('changePassword');
    }   

}])

