angular.module('app.controllers')

.controller('changePasswordCtrl', ['$scope', '$stateParams', '$rootScope', '$ionicPlatform', '$ionicPopup', 'participantService', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $rootScope, $ionicPlatform, $ionicPopup, participantService) {
    
    $scope.title = "Change Password";

    $scope.init = function(){
    	$scope.oldPass = '';
    	$scope.newPass = '';
    	$scope.confirmPass = '';
    }

    $scope.init();

    $scope.doChangePassword = function(){
    	if($scope.checkConfirmPassword()){
	    	var confirmPopup = $ionicPopup.confirm({
	     		title: 'Change Password',
	     		template: 'Are you sure you want to change your password?'
	     	});
	
	     	confirmPopup.then(function(res) {
	     		if(res) {
                    requestData = {
                        username:$rootScope.loggedInUser,
                        oldPassword: $scope.oldPass,
                        newPassword: $scope.newPass
                    }
	     		    participantService.changePassword(requestData).then(function(data){
	     		    	if(data.status===1){
	     		    		alert("Password changed successfully!");
	     		    		$scope.init();
	     		    	}
                        else if(!(data.status) || data === null)
                            alert("Current password is not correct, please try again!");
	     		    	else if(data.status===0)
	     		    		alert("Change password failed, please try again!");
	     		    	else
	     		    		alert("Connection error, please try again!" + data.err);
	     		    })
	     		}
	     	});
    	}
    	else{
    		alert("Confirm password does not match, please try again!");
    	}
    }

    $scope.checkConfirmPassword =function(){
    	if($scope.newPass === $scope.confirmPass)
    		return true;
    	else    		
    		return false;
    }

}])

