angular.module('app.controllers')

.controller('historyTransactionCtrl', ['$scope', '$state', '$stateParams', '$rootScope', '$ionicPlatform', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $state, $stateParams, $rootScope, $ionicPlatform) {
    
    $scope.title = "Transaction History";
    $scope.transactionList = $rootScope.transactionList;
    $scope.particpantName = $rootScope.particpantName;
    $scope.currentBalance = $rootScope.loggedInUserData.balance;
    $scope.active = '';
    $scope.customPadding = $rootScope.customPadding;

    $scope.filterTrans = function(type) {
        if(type !== $scope.active){
            $scope.active = type;
            var obj = $rootScope.transactionList.filter(function (val) {
                return val.type === type;
            });

            $scope.transactionList = obj;
        }
        else{
            $scope.active = '';
            $scope.transactionList = $rootScope.transactionList;
        }
    };

    $scope.isActive = function(type) {
        return type === $scope.active;
    }; 


    $scope.transactionList.forEach(function(item){
        item.transaction_id = $rootScope.formatNumber(item.transaction_id, 6);
        if(parseInt(item.void_transaction_id) === 0 || item.void_transaction_id === '')
            item.void_transaction_id = '';            
        else
            item.void_transaction_id = $rootScope.formatNumber(item.void_transaction_id, 6);
        
        if(item.giftcard !== '')
            item.useGiftCardText = 'Giftcard used';

        item.formatedCurrency = parseFloat(item.total_amount).toFixed(2);

        switch(item.type){
            case 'Void':
                item.txtColor = '#fa0000';
                break;
            case 'Purchase':
                item.txtColor = '#1681c3';
                break;
            case 'Top Up':
            case 'Refund':
                item.txtColor = '#00a953';
                break;
        }      
            
    })

    $scope.showTrans = function(transId){        
        var transaction;
        var obj = $scope.transactionList.filter(function (val) {
            return parseInt(val.transaction_id) === parseInt(transId);
        });

        // Filter returns an array, and we just want the matching item.
        $rootScope.transaction = obj[0];        

        $state.go('transactionDetails',{}, {reload:true});
    }   

}])