angular.module('app.services')
.factory('participantService', function($http, $rootScope) {

	var returnData = {};

	return {
		getParticipantByQRCode: function(qrcode){
			var URL = $rootScope.API_SERVER + "?action=pInfo";
            URL += "&qr_code=" + qrcode;

            return $rootScope.GETPromise(URL);
        },

        login: function(args){
            requestData = JSON.stringify(args);
            //console.log(requestData);

            var URL = $rootScope.API_SERVER;
            URL += "?action=login";
            
            return $http({
                    method: 'POST',
                    url: URL,
                    data: requestData,
                    headers: {'Content-Type': 'application/json'}
                })
            .then(function(resp){
                returnData = resp.data;                     
                return returnData;                
            }, function(err){                
                returnData.status = -500;
                return returnData;
            })
        },

        insertNewParticipant: function(args){
			requestData = JSON.stringify(args);

            var URL = $rootScope.API_SERVER;
            URL += "?action=registerUser";
            
            return $http({
                    method: 'POST',
                    url: URL,
                    data: requestData,
                    headers: {'Content-Type': 'application/json'}
                })
            .then(function(resp){
                returnData = resp.data;                     
                return returnData;                
            }, function(err){                
                returnData.status = -500;
                return returnData;
            })
		},

        voidRegistration: function(participantId, invoiceId){
            var URL = $rootScope.API_SERVER + "?action=voidRegister";
            URL += "&participant_id=" + participantId;
            URL += "&invoice_id=" + invoiceId;

            return $rootScope.GETPromise(URL);

        },

        changePassword: function(requestData){
            var URL = $rootScope.API_SERVER + "?action=changePass";

            return $rootScope.POSTPromise(URL, requestData);

        },

        recoverPassword: function(email){
            var URL = $rootScope.API_SERVER + "?action=recoverPass";
            URL += "&email=" + email;

            return $rootScope.GETPromise(URL);
        },

        getTransactionListByParticipantId: function(participant_id){
            var URL = $rootScope.API_SERVER + "?action=transCustomer";
            URL += "&username="+participant_id;

            return $rootScope.GETPromise(URL);
        },

        getInfoById: function(participant_id){
            var URL = $rootScope.API_SERVER + "?action=pInfoById";
            URL += "&participant_id="+participant_id;

            return $rootScope.GETPromise(URL);
        }
	}
	
})